// MFC-SampleDlg.cpp : implementation file
//

#include "stdafx.h"

#include <gdiplus.h>

using namespace Gdiplus;

#include "MFC-Sample.h"
#include "MFC-SampleDlg.h"

#include "WSDL3.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// Export helper

BOOL SaveCode(Bitmap *b,CString path);
int GetEncoderClsid(const WCHAR* format, CLSID* pClsid);

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMFCSampleDlg dialog


CMFCSampleDlg::CMFCSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFCSampleDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFCSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMFCSampleDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RESET, &CMFCSampleDlg::OnBnClickedReset)
	ON_BN_CLICKED(IDC_REFRESH, &CMFCSampleDlg::OnBnClickedRefresh)
	ON_BN_CLICKED(IDC_SAVE, &CMFCSampleDlg::OnBnClickedSave)
END_MESSAGE_MAP()

// CMFCSampleDlg message handlers

BOOL CMFCSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Fill dialog controls

	GetProperties();

	// Unlock library

	WSDL3unlock("LXXXXX-XXXXX","WSDL3-XXXX-XXXXXXXX");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMFCSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CMFCSampleDlg::GetProperties()
{
	char *dataToEncode = WSDL3getDataToEncode();
	CEdit *e = (CEdit *)GetDlgItem(IDC_DATATOENCODE);
	e->SetWindowText((LPCTSTR)dataToEncode);

	float moduleSize = WSDL3getModuleSize();
	e = (CEdit *)GetDlgItem(IDC_MODULESIZE);
	
	char t[32];
	sprintf(t,"%.1g",moduleSize);
	e->SetWindowText(t);

}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFCSampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this);
		Graphics g(dc);

		// Paint background

		CStatic *frame = (CStatic *)GetDlgItem(IDC_FRAME);
		CRect r;
		frame->GetWindowRect(&r);
		ScreenToClient(&r);
		SolidBrush whiteBrush(Color(255,255,255));
		g.FillRectangle(&whiteBrush,r.left,r.top,r.Width(),r.Height());

		// Create a barcode with the screen resolution and paint it

		Bitmap *barcode = WSDL3createCode(96);
		g.DrawImage(barcode,PointF(r.left,r.top));
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.

HCURSOR CMFCSampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CMFCSampleDlg::OnBnClickedReset()
{
	WSDL3resetToDefaults();
	GetProperties();
	Invalidate();
}

void CMFCSampleDlg::OnBnClickedRefresh()
{
	char buffer[128];

	CEdit *e = (CEdit *)GetDlgItem(IDC_DATATOENCODE);
	e->GetWindowText(buffer,127);
	WSDL3setDataToEncode(buffer);

	e = (CEdit *)GetDlgItem(IDC_MODULESIZE);
	e->GetWindowText(buffer,127);
	WSDL3setModuleSize((float)atof(buffer));

	Invalidate();
}

void CMFCSampleDlg::OnBnClickedSave()
{
	Bitmap *barcode = WSDL3createCode(300);

	char *filter = _T("PNG Image\0*.png\0All Files\0*.*\0");
				
	CFileDialog save(FALSE,"png",NULL,OFN_OVERWRITEPROMPT,filter);
	if(save.DoModal() == IDOK)
	{
		SaveCode(barcode, save.GetPathName());
	}
}

// Export helper

BOOL SaveCode(Bitmap *b,CString path)
{
	USES_CONVERSION;
	CLSID encoder;
	EncoderParameters parms;

	if(b == NULL || strlen(path) == 0) 
		return FALSE;

	ULONG quality = 90;
	parms.Count = 1;
	parms.Parameter[0].Guid = EncoderQuality;	
	parms.Parameter[0].Type = EncoderParameterValueTypeLong;
	parms.Parameter[0].NumberOfValues = 1;
	parms.Parameter[0].Value = &quality;

	CString ext = "png";
	CString mime = "image/" + ext;
	GetEncoderClsid(A2CW(mime),&encoder);
	Status result = b->Save(A2CW(path),&encoder,NULL);

	if(result == Ok)
		return TRUE;
	return FALSE;
}

// c.f. http://msdn.microsoft.com/library/en-us/gdicpp/GDIPlus/usingGDIPlus/usingimageencodersanddecoders/retrievingthe.asp?frame=true

int GetEncoderClsid(const WCHAR* format, CLSID* pClsid)
{
   UINT  num = 0;          
   UINT  size = 0;         

   ImageCodecInfo* pImageCodecInfo = NULL;

   GetImageEncodersSize(&num, &size);
   if(size == 0)
      return -1;  // Failure

   pImageCodecInfo = (ImageCodecInfo*)(malloc(size));
   if(pImageCodecInfo == NULL)
      return -1;  // Failure

   GetImageEncoders(num, size, pImageCodecInfo);

   for(UINT j = 0; j < num; ++j)
   {
      if( wcscmp(pImageCodecInfo[j].MimeType, format) == 0 )
      {
         *pClsid = pImageCodecInfo[j].Clsid;
         free(pImageCodecInfo);
         return j;  // Success
      }    
   }

   free(pImageCodecInfo);
   return -1;  // Failure
}